Project Chrono: chrono::vehicle::Wheel Class Reference

Public Member Functions | List of all members
chrono::vehicle::Wheel Class Reference
VEHICLE module » Wheeled vehicles » Wheel subsystem

## Description

Vehicle wheel constructed with data from file (JSON format).

`#include <Wheel.h>`

Inheritance diagram for chrono::vehicle::Wheel:
[legend]
Collaboration diagram for chrono::vehicle::Wheel:
[legend]

## Public Member Functions
| Wheel (const std::string &filename)
| Wheel (const rapidjson::Document &d)
virtual double | GetWheelMass () const override
virtual const ChVector3d & | GetWheelInertia () const override
virtual double | GetRadius () const override
| Get the wheel radius (for visualization only).
virtual double | GetWidth () const override
| Get the wheel width (for visualization only).
void | SetRadius (double rad)
void | SetWidth (double width)
Public Member Functions inherited from chrono::vehicle::ChWheel
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, std::shared_ptr< ChBody > spindle, VehicleSide side, double offset=0)
| Initialize this wheel subsystem by associating it to an existing spindle of a suspension subsystem.
void | EnableCollision (bool state)
| Enable/disable contact for the wheel.
void | Synchronize ()
| Synchronize the wheel subsystem.
void | Synchronize (const TerrainForce &tire_force)
| Synchronize the wheel subsystem.
std::shared_ptr< ChTire > | GetTire () const
| Get the tire attached to this wheel.
void | SetTire (std::shared_ptr< ChTire > tire)
| Associate the given tire with this wheel.
std::shared_ptr< ChBody > | GetSpindle () const
| Get the associated spindle body.
VehicleSide | GetSide () const
| Get the vehicle side on which this wheel is mounted.
ChVector3d | GetPos () const
| Get wheel position (expressed in absolute frame).
WheelState | GetState () const
| Get the current state for this wheel.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the wheel subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the wheel subsystem.
const std::string & | GetMeshFilename () const
| Get the name of the Wavefront file with wheel visualization mesh.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const
| Output data for this subsystem's component list to the specified database.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChWheel
| ChWheel (const std::string &name)
| Construct a wheel subsystem with given name.
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChWheel
std::shared_ptr< ChBody > | m_spindle
| associated suspension spindle body
std::shared_ptr< ChTire > | m_tire
| attached tire subsystem
VehicleSide | m_side
| wheel mounted on left/right side
double | m_offset
| offset from spindle center
std::string | m_vis_mesh_file
| visualization mesh file (may be empty)
std::shared_ptr< ChVisualShapeTriangleMesh > | m_trimesh_shape
| visualization mesh asset
std::shared_ptr< ChVisualShape > | m_cyl_shape
| visualization cylinder asset
std::shared_ptr< ChLoadBodyForce > | m_spindle_terrain_force
| terrain force loads on the spindle
std::shared_ptr< ChLoadBodyTorque > | m_spindle_terrain_torque
| terrain torque loads on the spindle
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetRadius()

virtual double chrono::vehicle::Wheel::GetRadius | ( |  | ) | const
| inlineoverridevirtual

Get the wheel radius (for visualization only).

Reimplemented from chrono::vehicle::ChWheel.

## ◆ GetWheelInertia()

virtual const ChVector3d & chrono::vehicle::Wheel::GetWheelInertia | ( |  | ) | const
| inlineoverridevirtual

Implements chrono::vehicle::ChWheel.

## ◆ GetWheelMass()

virtual double chrono::vehicle::Wheel::GetWheelMass | ( |  | ) | const
| inlineoverridevirtual

Implements chrono::vehicle::ChWheel.

## ◆ GetWidth()

virtual double chrono::vehicle::Wheel::GetWidth | ( |  | ) | const
| inlineoverridevirtual

Get the wheel width (for visualization only).

Reimplemented from chrono::vehicle::ChWheel.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/wheel/Wheel.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/wheel/Wheel.cpp